/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		NiMHdrp[dԊ֐
 *
 *		NiMH[d@ɉ[dԊ֐ƒg֐܂݂܂B
 *
 * \par pLq:
 *		AVR463: BC100łƯِfdȑ[d\n
 *
 * \par 
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com
 *
 * $Name$
 * $Revision: 2255 $
 * $RCSfile$
 * $URL: http://svn.norway.atmel.com/AppsAVR8/avr463_Charging_NiMH_Batteries_with_BC100/trunk/code/IAR/NIMHcharge.c $
 * $Date: 2007-08-09 14:47:58 +0200 (to, 09 aug 2007) $\n
 ******************************************************************************/

#include <ioavr.h>

#include "enums.h"
#include "structs.h"

#include "battery.h"
#include "charge.h"
#include "chargefunc.h"
#include "main.h"
#include "menu.h"
#include "NIMHspecs.h"
#include "PWM.h"
#include "time.h"

#ifndef NIMH
#error main.hNIMH`!
#endif // NIMH

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief [d
 *
 * ̊֐͊eiKɕꂽg̏[d@܂݂܂B\n
 * eiKɑ΂PWMJn/~AvA~A[dҰݒ肳꓾
 * B\n
 * [d֐͕K̏ԂԂAُ킪NȂ肱͎̏[dԂłB
 *
 * \note ƒiKKvƂȂAPmenu.hɂƏԂ`Amenu.c
 *  \ref menu_state[] ł܂߁AĂ̊֐caseǉĂB
 *
 * \note ̕@NiMHdrpłB
 */
unsigned char Charge(unsigned char inp)
{
	unsigned char NextState;

	switch (CurrentState) {
	case ST_PREQUAL:		/* \[d */
	// 2ԁA0.1C̓dp1Vւ̓dr[d݂܂B
	// ꂪsȂAdr͑ċłBȂ΋}[dJn܂B
		ChargeParameters.Current = BattData.Capacity / 10;			// 0.1C[dw
		ChargeParameters.NextState = ST_FASTCHARGE;					// ̏Ԃ}[dɎw
		HaltParameters.HaltFlags = (HALT_VOLTAGE_MAX | HALT_TIME |	// ~׸ގw(dBƎԒ)
		                            HALT_FLAG_EXHAUSTION);			// (Ԓ߂͏ՓdrӖ܂B)
		HaltParameters.VoltageMax = BAT_VOLTAGE_PREQUAL;			// dw
		HaltParameters.TemperatureMin = BAT_TEMPERATURE_MIN;		// xw
		HaltParameters.TemperatureMax = 35;							// xw
		HaltParameters.LastNTC = 0;									// O񑪒艷xl(HaltNow()p)
		PWM_Start();												// PWMJn
		Time_Set(TIMER_CHG, BAT_TIME_PREQUAL, 0, 0);				// \[dvn
		NextState = ConstantCurrent();								// [d̎̏ԂdɎw
	break;
	case ST_FASTCHARGE:		/* }[d */
	// xxdxɒB邩A܂͏\ȓdቺ܂ŁAő1.51.0Cŏ[d܂B
	// ł̎Ԓ߂͏ՓdrӖ܂B
		ChargeParameters.Current = BattData.Capacity;				// 1.0C[dw
		ChargeParameters.NextState = ST_LOWRATECHARGE;				// ̏Ԃᑬ[dɎw
		HaltParameters.HaltFlags = (HALT_VOLTAGE_MAX | HALT_TIME |	// ~׸ގw(dBAԒ߁AdቺƉx㏸)
		                            HALT_VOLTAGE_DROP | HALT_TEMPERATURE_RISE);
		HaltParameters.VoltageMax = BAT_VOLTAGE_MAX;				// dw
		HaltParameters.VoltageDrop = BAT_VOLTAGE_DROP;				// dቺw
		HaltParameters.TemperatureMax = BAT_TEMPERATURE_MAX;		// xw
		HaltParameters.TemperatureRise = 1;							// x㏸w(1)
		HaltParameters.VBATMax = 0;									// ōdl(HaltNow()p)
		Time_Set(TIMER_CHG, BattData.MaxTime, 0, 0);				// }[dvn(PWM͖쒆)
		NextState = ConstantCurrent();								// [d̎̏ԂdɎw
	break;
	case ST_LOWRATECHARGE:	/* ᑬ[d */
	// xx܂͓dxɒB܂ŁAő300.1Cŏ[d܂B
		ChargeParameters.Current = BattData.Capacity / 10;			// 0.1C[dw
		ChargeParameters.NextState = ST_ENDCHARGE;					// ̏Ԃ[dIɎw
		HaltParameters.HaltFlags = (HALT_VOLTAGE_MAX | HALT_TIME |	// ~׸ގw(dBAԒ߂Ɖx㏸)
		                            HALT_TEMPERATURE_RISE);
		Time_Set(TIMER_CHG, 30, 0, 0);								// ᑬ[dvn
		NextState = ConstantCurrent();								// [d̎̏ԂdɎw
	break;
	case ST_ENDCHARGE:		/* [dI */
		PWM_Stop();													// PWM~
		BattData.Charged = TRUE;									// [dς׸ސݒ
		if (BattControl[(BattActive+1)%2].Enabled) {				// ̓drȂA
			NextState = ST_BATCON;									// ̏ԂdrɎw
		} else {													// ̓dr֎~ȂA
			NextState = ST_SLEEP;									// ̏Ԃx~(ذ)Ɏw
		}
	break;

	default:				// ŏI点Ă͂܂BŜ߂ɍď܂B
		NextState = ST_INIT;										// ̏ԂɎw
		break;
	}
	return(NextState);		// main()ւ̎̏ԕƋɕA
}
