/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		[d֐
 *
 *		dƒdł̏[dƒ~鎞肷邽߂̊֐܂݂܂B
 *
 * \par pLq
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *
 * \par :
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com
 *
 * $Name$
 * $Revision: 2299 $
 * $RCSfile$
 * $URL: http://svn.norway.atmel.com/AppsAVR8/avr463_Charging_NiMH_Batteries_with_BC100/tags/20070904_release_code_1.0/code/IAR/chargefunc.c $
 * $Date: 2007-08-23 12:55:51 +0200 (to, 23 aug 2007) $\n
 ******************************************************************************/

#include <ioavr.h>

#include "enums.h"
#include "structs.h"

#include "ADC.h"
#include "battery.h"
#include "chargefunc.h"
#include "main.h"
#include "menu.h"
#include "PWM.h"
#include "statefunc.h"
#include "time.h"

#ifdef NIMH
#include "NIMHspecs.h"
#endif // NIMH

#ifdef LIION
#include "LIIONspecs.h"
#endif // LIION

//******************************************************************************
// ϐ
//******************************************************************************
ChargeParameters_t ChargeParameters;	//! ConstantCurrent()ConstantVoltage()pҰێ\
HaltParameters_t HaltParameters;		//! HaltNow()pҰێ\

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief dœdr[d
 *
 * ̊֐HaltNow()TRUEԂA܂\ref ABORT_IF_PWM_MIN
 * \ref ABORT_IF_PWM_MAX`APWMُ킪N܂ŁAdrɑ΂
 * (ChargeParameters.CurrentŐݒ肳ꂽ)d܂B\n
 * [dd́} \ref BAT_CURRENT_HYST ŕς蓾܂B\n
 * 呕u[d֎~ꍇAv킪~APWMo͂Ƃ܂Bdr[
 * d֎~̍}͂₳ȂȂAv킪ĂъJnď[dĊJ܂B
 *
 * \retval ChargeParameters.NextState	̒iKI̎̏
 * ُȋNȂȂACharge()ŉݒ肳ꂽł傤BȂ
 * ΁AHaltNow()V̏Ԃݒ肷ł傤B
 */
unsigned char ConstantCurrent(void)
{
	unsigned char error = FALSE,
				  wasStopped = FALSE;

	do	{
		ADC_Wait();										// A/Dϊҋ@
		if (BattControl[BattActive].ChargeInhibit) {	// 呕u[d֎~}ȂA[dꎞ~
			wasStopped = TRUE;							// (͒ʐM̑h߂łB)
			Time_Stop();
			OCR1B = 0;
		} else {										// ֎~vȂŁA[dp
			if (wasStopped) {
				wasStopped = FALSE;
				Time_Start();							// (vϐ͂ɂؾĂ܂B)
			}
			if ((ADCS.avgIBAT < 0) ||					// [ddChargeParameters.Current}BAT_CURRENT_HYSTɒ(+)
			    (ADCS.avgIBAT < (ChargeParameters.Current - BAT_CURRENT_HYST))) {

				if(!PWM_IncrementDutyCycle()) {			// ޭè ّs\ŁAُ׸ސݒAُԐݒ
#ifdef ABORT_IF_PWM_MAX
					SetErrorFlag(ERR_PWM_CONTROL);
					ChargeParameters.NextState = ST_ERROR;
					error = TRUE;
#endif
				}
			} else if ((ADCS.avgIBAT >= 0) &&			// [ddChargeParameters.Current}BAT_CURRENT_HYSTɒ(-)
				 (ADCS.avgIBAT > (ChargeParameters.Current + BAT_CURRENT_HYST))) {

				if(!PWM_DecrementDutyCycle()) {			// ޭè ٌs\ŁAُ׸ސݒAُԐݒ
#ifdef ABORT_IF_PWM_MIN
					SetErrorFlag(ERR_PWM_CONTROL);
					ChargeParameters.NextState = ST_ERROR;
					error = TRUE;
#endif
				}
			}
		}
	} while (!HaltNow() && !error);
	return(ChargeParameters.NextState);		// Charge()Ɏ̏ԂԂ܂B
											// ُ킪NꍇA͏[d̎̏Ԃł͂Ȃʂ̏Ԃ܂B
}

/*! \brief dœdr[d
 *
 * ̊֐HaltNow()TRUEԂA܂\ref ABORT_IF_PWM_MIN
 * \ref ABORT_IF_PWM_MAX`APWMُ킪N܂ŁAdrɑ΂
 * (ChargeParameters.VoltageŐݒ肳ꂽ)d܂B\n
 * [dd́} \ref BAT_VOLTAGE_HYST ŕς蓾܂B\n
 * 呕u[d֎~ꍇAv킪~APWMo͂Ƃ܂Bdr[
 * d֎~̍}͂₳ȂȂAv킪ĂъJnď[dĊJ܂B
 *
 * \retval ChargeParameters.NextState	̒iKI̎̏
 * ُȋNȂȂACharge()ŉݒ肳ꂽł傤BȂ
 * ΁AHaltNow()V̏Ԃݒ肷ł傤B
 */
unsigned char ConstantVoltage(void)
{
	unsigned char error = FALSE,
				  wasStopped = FALSE;
	
	do{
		ADC_Wait();										// A/Dϊҋ@
		if (BattControl[BattActive].ChargeInhibit) {	// 呕u[d֎~}ȂA[dꎞ~
			wasStopped = TRUE;							// (͒ʐM̑h߂łB)
			Time_Stop();
			OCR1B = 0;
		}
		else {											// ֎~vȂŁA[dp
			if (wasStopped) {
				wasStopped = FALSE;
				Time_Start();							// (vϐ͂ɂؾĂ܂B)
			}
			if (ADCS.VBAT < (ChargeParameters.Voltage - BAT_VOLTAGE_HYST)) {	// [ddChargeParameters.Current}BAT_VOLTAGE_HYSTɒ(+)

				if(!PWM_IncrementDutyCycle()) {			// ޭè ّs\ŁAُ׸ސݒAُԐݒ
#ifdef ABORT_IF_PWM_MAX
					SetErrorFlag(ERR_PWM_CONTROL);
					ChargeParameters.NextState = ST_ERROR;
					error = TRUE;
#endif
				}
			} else if (ADCS.VBAT > (ChargeParameters.Voltage + BAT_VOLTAGE_HYST)) {	// [ddChargeParameters.Current}BAT_VOLTAGE_HYSTɒ(-)

				if(!PWM_DecrementDutyCycle()) {			// ޭè ٌs\ŁAُ׸ސݒAُԐݒ
#ifdef ABORT_IF_PWM_MIN
					SetErrorFlag(ERR_PWM_CONTROL);
					ChargeParameters.NextState = ST_ERROR;
					error = TRUE;
#endif
				}
			}
		}
	} while (!HaltNow() && !error);
	return(ChargeParameters.NextState);		// Charge()Ɏ̏ԂԂ܂B
											// ُ킪NꍇA͏[d̎̏Ԃł͂Ȃʂ̏Ԃ܂B
}

/*! \brief [d~鎞̔
 *
 * ̊֐HaltParameters.HaltFlagsō}ꂽ̂ɈˑҰ]A
 * [d~邩ۂTRUE܂FALSEԂ܂B\n
 * āAԒ(dr)łُ̈׸ނݒ肳꓾܂B\n
 *
 * ֐͓drxxAdOKABatteryCheck()TRUEԂ
 * ܂Bُ킪oꂽꍇAAgُ׸ނݒ肳A
 * ChargeParameters.NextStateK؂ȏԂɕύX܂B
 *
 * \retval TRUE		ݒ~
 * \retval FALSE	ݒ~ł͂Ȃ
 *
 * \note ~׸ނ̒`ɂĂchargefunc.hB
 * \note Ԓ߂Œ~邱Ƃ͈ʓIɈlł͂܂B
 * \note HALT_ON_VOLTAGE_DROPݒ肳ꂽꍇA[d֐ĂԑOHaltParameters.VBATMaxCharge()ؾĂׂłB
 *
 * \todo Ẅُ팟"D揇"͑vł?
 */
unsigned char HaltNow(void)
{
	unsigned char i, halt = FALSE;

	ADC_Wait();		// A/Dϊ񊮗ҋ@

	for (i = 0x01; i != 0; i <<= 1) {	// HaltFlagsɏ]A/Dϊl]
		if (HaltParameters.HaltFlags & i) {
			switch (i) {
			case HALT_VOLTAGE_DROP:								// dቺ
				if (ADCS.VBAT > HaltParameters.VBATMax) {			// VBAT>݂܂ł̍ődŁA
					HaltParameters.VBATMax = ADCS.VBAT;				// ݂܂ł̍ődXV
				} else if((HaltParameters.VBATMax - ADCS.VBAT) >=	// VBAT݂܂ł̍ődAVቺdŁA
				          HaltParameters.VoltageDrop) {
					halt = TRUE;									// ~׸ސݒ
				}
			break;
			case HALT_VOLTAGE_MAX:								// őd
				if (ADCS.VBAT >= HaltParameters.VoltageMax) {		// VBATődŁA
					halt = TRUE;									// ~׸ސݒ
				}
				break;
			case HALT_CURRENT_MIN:								// ŏd
				if (ADCS.avgIBAT <= HaltParameters.CurrentMin) {	// IBATŏdŁA
					halt = TRUE;									// ~׸ސݒ
				}
				break;
			case HALT_TEMPERATURE_RISE:							// x㏸
				if (ADCS.rawNTC > HaltParameters.LastNTC) {			// x>OxŁA
					HaltParameters.LastNTC = ADCS.rawNTC;			// OxXV
					Time_Set(TIMER_TEMP,0,30,0);					// 30bvn
				} else  if ((HaltParameters.LastNTC - ADCS.rawNTC) >=		// xOxAx㏸xŁA
				  (BattData.ADCSteps * HaltParameters.TemperatureRise)) {
					if (Time_Left(TIMER_TEMP))  {							// 30bȓȂA
						halt = TRUE;										// ~׸ސݒ
					} else {												// 30bȏȂA
						HaltParameters.LastNTC = ADCS.rawNTC;				// x𒼑OxƂĐݒ
						Time_Set(TIMER_TEMP,0,30,0);						// 30bvn
					}
				}
			break;
			case HALT_TIME:										// [dԌ
				if (!Time_Left(TIMER_CHG)) {						// [dԌo߂ŁA
					halt = TRUE;									// ~׸ސݒ
					// If exhaustion flagging is selected, stop the PWM, disable the 
					// battery and flag it as exhausted. Make ST_ERROR next state.
					if (HaltParameters.HaltFlags & HALT_FLAG_EXHAUSTION) {	// Ղł̒~ŁA
							PWM_Stop();										// PWM~
							BattControl[BattActive].Enabled = FALSE;		// dr֎~
							BattData.Exhausted = TRUE;						// dr׸ސݒ
							SetErrorFlag(ERR_BATTERY_EXHAUSTED);
							ChargeParameters.NextState = ST_ERROR;			// ̏Ԃُُɐݒ
					}
				}
			break;
			default:	// ŏIׂł͂܂BMISRAK̂߂ɕKvƂ܂B
			break;
			}
		}
	}
	/* W */
	if ((BattData.Temperature <= HaltParameters.TemperatureMin) ||	// drxႷA܂͍ŁA
	    (BattData.Temperature >= HaltParameters.TemperatureMax)) {
		PWM_Stop();													// PWM~
		SetErrorFlag(ERR_BATTERY_TEMPERATURE);						// xُ׸ސݒ
		ChargeParameters.NextState = ST_ERROR;						// ̏Ԃُُɐݒ
		halt = TRUE;												// ~׸ސݒ
	}
	if (!BatteryCheck()) {											// drOKłȂ΁A
		PWM_Stop();													// PWM~
		ChargeParameters.NextState = ST_INIT;						// ̏Ԃɐݒ
		halt = TRUE;												// ~׸ސݒ
	}
	if (!ADCS.Mains) {												// dOKłȂ΁A
		PWM_Stop();													// PWM~
		ChargeParameters.NextState = ST_SLEEP;						// ̏Ԃx~(ذ)ɐݒ
		halt = TRUE;												// ~׸ސݒ
	}
	return(halt);												// ~׸ނƋɕA
}
