/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		chargefunc.cpͯ ̧
 *
 *		PWMُ폈̌ƒ~׸ނ̒`A[dpҰ\̂̐錾܂݂܂B
 *
 * \par pLq
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *
 * \par :
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com
 *
 * $Name$
 * $Revision: 2261 $
 * $RCSfile$
 * $URL: http://svn.norway.atmel.com/AppsAVR8/avr463_Charging_NiMH_Batteries_with_BC100/tags/20070904_release_code_1.0/code/IAR/chargefunc.h $
 * $Date: 2007-08-10 09:28:35 +0200 (fr, 10 aug 2007) $\n
 ******************************************************************************/

#ifndef CHARGEFUNC_H
#define CHARGEFUNC_H

//******************************************************************************
// PWMُ폈
//******************************************************************************
#define ABORT_IF_PWM_MAX	//! őޭè ق[ȏ[dd^ȂꍇɈُ񍐂܂B
#define ABORT_IF_PWM_MIN	//! ŏޭè ق傫[dd^ꍇɈُ񍐂܂B

//******************************************************************************
// HaltFlagsp`
//******************************************************************************
#define HALT_VOLTAGE_DROP		0x01	//! VBAT̒ቺݒx傫ꍇɒ~܂B
#define HALT_VOLTAGE_MAX		0x02	//! VBATőݒɒBꍇɒ~܂B
#define HALT_CURRENT_MIN		0x04	//! avgIBATŏݒȉɂȂꍇɒ~܂B
#define HALT_TEMPERATURE_RISE	0x08	//! BattData.Temperatureőݒf㏸ꍇɒ~܂B
#define HALT_TIME				0x10	//! TIMER_CHGo߂ꍇɒ~܂B
#define HALT_FLAG_EXHAUSTION	0x20	//! Ԓ߂Nꍇɓdr׸ސݒ

//******************************************************************************
// [dpҰ\
//******************************************************************************
/*! \brief ConstantCurrent() and ConstantVoltage()pҰێ܂B
 *
 */
struct ChargeParameters_struct {
	unsigned int Voltage;		//!< [dd
	unsigned int Current;		//!< [dd
	unsigned char NextState;	//!< \brief [diKUI̎̏
								//!< \note Charge()Őݒ肳܂Aُ킪NꍇHaltNow()ɂĕύX邩܂B
};
typedef struct ChargeParameters_struct ChargeParameters_t;

//******************************************************************************
// HaltNow()pҰ\
//******************************************************************************
/*! \brief HaltNow()pҰێ܂B
 *
 */
struct HaltParameters_struct {
	unsigned char HaltFlags;		//! \brief ]邽߂׸ނ܂݂܂B
									//! \note ׸ނ̒`ɂĂchargefunc.hB
	unsigned int VoltageDrop;		//! ~ɐ旧dɉmVł̍őቺ
	unsigned int VoltageMax;		//! mVł̏o͓d
	unsigned int CurrentMin;		//! mAł̏o͓d
	unsigned int TemperatureMax;	//! ł̓drx
	signed int TemperatureMin;		//! ł̓drx
	unsigned int TemperatureRise;	//! ́ł̉x㏸
	unsigned int VBATMax;			//! \brief dቺvZɎgpōVBAT܂݂܂B
									//! \note 蓮ؾĂȂ΂Ȃ܂B
	unsigned int LastNTC;			//! x㏸oɎgp܂B
};
typedef struct HaltParameters_struct HaltParameters_t;

//******************************************************************************
// S̕ϐ
//******************************************************************************
extern ChargeParameters_t ChargeParameters;
extern HaltParameters_t HaltParameters;

//******************************************************************************
// ֐^錾
//******************************************************************************
unsigned char ConstantCurrent(void);
unsigned char ConstantVoltage(void);
unsigned char HaltNow(void);

#endif // CHARGEFUNC_H
